VERSION 5.00
Begin VB.UserControl cmdButton 
   ClientHeight    =   600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1335
   DefaultCancel   =   -1  'True
   ScaleHeight     =   40
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   89
   ToolboxBitmap   =   "MOCMD.ctx":0000
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   120
      Top             =   240
   End
   Begin VB.CommandButton cmdButton 
      Cancel          =   -1  'True
      Caption         =   "Button"
      Default         =   -1  'True
      Height          =   495
      Left            =   0
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "cmdButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Define user defined type for cursor position
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Dim highlight As Boolean
Dim strColor As ColorConstants
'Get cursor position
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

'Translate into windows coordinates
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long

'Default Property Values:
Const m_def_FillColor = 0
Const m_def_ForeColor = 0
Const m_def_BorderStyle = 0
Const m_def_BackStyle = 0
Dim m_MouseOverColor As OLE_COLOR
Dim m_ForeColor As OLE_COLOR
Dim m_BorderStyle As Integer
Dim m_BackStyle As Integer

Event Click() 'MappingInfo=cmdButton,cmdButton,-1,Click
Event OLECompleteDrag(Effect As Long) 'MappingInfo=cmdButton,cmdButton,-1,OLECompleteDrag
Attribute OLECompleteDrag.VB_Description = "Occurs at the OLE drag/drop source control after a manual or automatic drag/drop has been completed or canceled."
Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=cmdButton,cmdButton,-1,OLEDragDrop
Attribute OLEDragDrop.VB_Description = "Occurs when data is dropped onto the control via an OLE drag/drop operation, and OLEDropMode is set to manual."
Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer) 'MappingInfo=cmdButton,cmdButton,-1,OLEDragOver
Attribute OLEDragOver.VB_Description = "Occurs when the mouse is moved over the control during an OLE drag/drop operation, if its OLEDropMode property is set to manual."
Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean) 'MappingInfo=cmdButton,cmdButton,-1,OLEGiveFeedback
Attribute OLEGiveFeedback.VB_Description = "Occurs at the source control of an OLE drag/drop operation when the mouse cursor needs to be changed."
Event OLESetData(Data As DataObject, DataFormat As Integer) 'MappingInfo=cmdButton,cmdButton,-1,OLESetData
Attribute OLESetData.VB_Description = "Occurs at the OLE drag/drop source control when the drop target requests data that was not provided to the DataObject during the OLEDragStart event."
Event OLEStartDrag(Data As DataObject, AllowedEffects As Long) 'MappingInfo=cmdButton,cmdButton,-1,OLEStartDrag
Attribute OLEStartDrag.VB_Description = "Occurs when an OLE drag/drop operation is initiated either manually or automatically."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=cmdButton,cmdButton,-1,KeyDown
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=cmdButton,cmdButton,-1,KeyPress
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=cmdButton,cmdButton,-1,KeyUp
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=cmdButton,cmdButton,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=cmdButton,cmdButton,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=cmdButton,cmdButton,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."



Private Sub Timer1_Timer()
Dim MOT As POINTAPI 'Define a variable for cursor position
    
    GetCursorPos MOT    'put cursor position into MOT
    
    ScreenToClient hWnd, MOT    'Make it aware of window
    
    'Determine if still inside of cmdButton
    If MOT.X < cmdButton.Left Or MOT.Y < cmdButton.Top Or _
       MOT.X > cmdButton.Left + cmdButton.Width Or _
       MOT.Y > cmdButton.Top + cmdButton.Height _
    Then
        cmdButton.BackColor = strColor
        highlight = False
        Timer1.Enabled = False
    End If
End Sub

Private Sub UserControl_Initialize()
    strColor = &H8000000F
End Sub

Private Sub UserControl_Resize()
    'resize button according to usercontrol
    'strColor = cmdButton.BackColor
    cmdButton.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = cmdButton.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    cmdButton.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    strColor = cmdButton.BackColor
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = cmdButton.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    cmdButton.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = cmdButton.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set cmdButton.Font = New_Font
    PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
    BackStyle = m_BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    m_BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5
Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
     
End Sub

Private Sub cmdButton_Click()
    RaiseEvent Click
End Sub

Private Sub cmdButton_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub cmdButton_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub cmdButton_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub cmdButton_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub cmdButton_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
    If highlight Then Exit Sub
    'cmdButton.SetFocus
    cmdButton.BackColor = MouseOverColor
    Timer1.Enabled = True
    highlight = True
End Sub

Private Sub cmdButton_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Appearance
Public Property Get Appearance() As Integer
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
    Appearance = cmdButton.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    cmdButton.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Cancel
Public Property Get Cancel() As Boolean
Attribute Cancel.VB_Description = "Indicates whether a command button is the Cancel button on a form."
    Cancel = cmdButton.Cancel
End Property

Public Property Let Cancel(ByVal New_Cancel As Boolean)
    cmdButton.Cancel() = New_Cancel
    PropertyChanged "Cancel"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
    Caption = cmdButton.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    cmdButton.Caption() = New_Caption
    PropertyChanged "Caption"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,CausesValidation
Public Property Get CausesValidation() As Boolean
Attribute CausesValidation.VB_Description = "Returns/sets whether validation occurs on the control which lost focus."
    CausesValidation = cmdButton.CausesValidation
End Property

Public Property Let CausesValidation(ByVal New_CausesValidation As Boolean)
    cmdButton.CausesValidation() = New_CausesValidation
    PropertyChanged "CausesValidation"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Default
Public Property Get Default() As Boolean
Attribute Default.VB_Description = "Determines which CommandButton control is the default command button on a form."
    Default = cmdButton.Default
End Property

Public Property Let Default(ByVal New_Default As Boolean)
    cmdButton.Default() = New_Default
    PropertyChanged "Default"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,DownPicture
Public Property Get DownPicture() As Picture
Attribute DownPicture.VB_Description = "Returns/sets a graphic to be displayed when the button is in the down position, if Style is set to 1."
    Set DownPicture = cmdButton.DownPicture
End Property

Public Property Set DownPicture(ByVal New_DownPicture As Picture)
    Set cmdButton.DownPicture = New_DownPicture
    PropertyChanged "DownPicture"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,MaskColor
Public Property Get MaskColor() As Long
Attribute MaskColor.VB_Description = "Returns or sets a color in a button's picture to be a 'mask' (that is, transparent), if Style is set to 1."
    MaskColor = cmdButton.MaskColor
End Property

Public Property Let MaskColor(ByVal New_MaskColor As Long)
    cmdButton.MaskColor() = New_MaskColor
    PropertyChanged "MaskColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Picture
Public Property Get Picture() As Picture
Attribute Picture.VB_Description = "Returns/sets a graphic to be displayed in a CommandButton, OptionButton or CheckBox control, if Style is set to 1."
    Set Picture = cmdButton.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set cmdButton.Picture = New_Picture
    PropertyChanged "Picture"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,RightToLeft
Public Property Get RightToLeft() As Boolean
Attribute RightToLeft.VB_Description = "Determines text display direction and control visual appearance on a bidirectional system."
    RightToLeft = cmdButton.RightToLeft
End Property

Public Property Let RightToLeft(ByVal New_RightToLeft As Boolean)
    cmdButton.RightToLeft() = New_RightToLeft
    PropertyChanged "RightToLeft"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,Style
Public Property Get Style() As Integer
Attribute Style.VB_Description = "Returns/sets the appearance of the control, whether standard (standard Windows style) or graphical (with a custom picture)."
    Style = cmdButton.Style
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,UseMaskColor
Public Property Get UseMaskColor() As Boolean
Attribute UseMaskColor.VB_Description = "Returns or sets a value that determines whether the color assigned in the MaskColor property is used as a 'mask'. (That is, used to create transparent regions.)  Applies only if Style is set to 1."
    UseMaskColor = cmdButton.UseMaskColor
End Property

Public Property Let UseMaskColor(ByVal New_UseMaskColor As Boolean)
    cmdButton.UseMaskColor() = New_UseMaskColor
    PropertyChanged "UseMaskColor"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
'    m_ForeColor = m_def_ForeColor
    m_BackStyle = m_def_BackStyle
'    m_BorderStyle = m_def_BorderStyle
'    m_FillColor = m_def_FillColor
    m_ForeColor = m_def_ForeColor
'    m_FillColor = m_def_FillColor
    m_BorderStyle = m_def_BorderStyle
'    m_FillColor = m_def_FillColor
    m_MouseOverColor = m_def_FillColor
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    cmdButton.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    'very important to leave the above line
    strColor = cmdButton.BackColor
    'very important to leave the above line
'    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    cmdButton.Enabled = PropBag.ReadProperty("Enabled", True)
    Set cmdButton.Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_BackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
'    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    cmdButton.Appearance = PropBag.ReadProperty("Appearance", 1)
    cmdButton.Cancel = PropBag.ReadProperty("Cancel", False)
    cmdButton.Caption = PropBag.ReadProperty("Caption", "Button")
    cmdButton.CausesValidation = PropBag.ReadProperty("CausesValidation", True)
    cmdButton.Default = PropBag.ReadProperty("Default", False)
    Set DownPicture = PropBag.ReadProperty("DownPicture", Nothing)
'    m_FillColor = PropBag.ReadProperty("FillColor", m_def_FillColor)
    cmdButton.MaskColor = PropBag.ReadProperty("MaskColor", 12632256)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    cmdButton.RightToLeft = PropBag.ReadProperty("RightToLeft", False)
    cmdButton.UseMaskColor = PropBag.ReadProperty("UseMaskColor", False)
    cmdButton.OLEDropMode = PropBag.ReadProperty("OLEDropMode", 0)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
'    m_FillColor = PropBag.ReadProperty("FillColor", m_def_FillColor)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
'    m_FillColor = PropBag.ReadProperty("FillColor", m_def_FillColor)
    m_MouseOverColor = PropBag.ReadProperty("MouseOverColor", m_def_FillColor)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", cmdButton.BackColor, &H8000000F)
'    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("Enabled", cmdButton.Enabled, True)
    Call PropBag.WriteProperty("Font", cmdButton.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", m_BackStyle, m_def_BackStyle)
'    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Appearance", cmdButton.Appearance, 1)
    Call PropBag.WriteProperty("Cancel", cmdButton.Cancel, False)
    Call PropBag.WriteProperty("Caption", cmdButton.Caption, "Button")
    Call PropBag.WriteProperty("CausesValidation", cmdButton.CausesValidation, True)
    Call PropBag.WriteProperty("Default", cmdButton.Default, False)
    Call PropBag.WriteProperty("DownPicture", DownPicture, Nothing)
'    Call PropBag.WriteProperty("FillColor", m_FillColor, m_def_FillColor)
    Call PropBag.WriteProperty("MaskColor", cmdButton.MaskColor, 12632256)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("RightToLeft", cmdButton.RightToLeft, False)
    Call PropBag.WriteProperty("UseMaskColor", cmdButton.UseMaskColor, False)
    Call PropBag.WriteProperty("OLEDropMode", cmdButton.OLEDropMode, 0)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
'    Call PropBag.WriteProperty("FillColor", m_FillColor, m_def_FillColor)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
'    Call PropBag.WriteProperty("FillColor", m_FillColor, m_def_FillColor)
    Call PropBag.WriteProperty("MouseOverColor", m_MouseOverColor, m_def_FillColor)
End Sub

Private Sub cmdButton_OLECompleteDrag(Effect As Long)
    RaiseEvent OLECompleteDrag(Effect)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,OLEDrag
Public Sub OLEDrag()
Attribute OLEDrag.VB_Description = "Starts an OLE drag/drop event with the given control as the source."
    cmdButton.OLEDrag
End Sub

Private Sub cmdButton_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub

Private Sub cmdButton_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=cmdButton,cmdButton,-1,OLEDropMode
Public Property Get OLEDropMode() As Integer
Attribute OLEDropMode.VB_Description = "Returns/Sets whether this object can act as an OLE drop target."
    OLEDropMode = cmdButton.OLEDropMode
End Property

Public Property Let OLEDropMode(ByVal New_OLEDropMode As Integer)
    cmdButton.OLEDropMode() = New_OLEDropMode
    PropertyChanged "OLEDropMode"
End Property

Private Sub cmdButton_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub cmdButton_OLESetData(Data As DataObject, DataFormat As Integer)
    RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub cmdButton_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    m_BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,0
Public Property Get MouseOverColor() As OLE_COLOR
Attribute MouseOverColor.VB_Description = "Returns/sets the color used to fill in shapes, circles, and boxes."
    MouseOverColor = m_MouseOverColor
End Property

Public Property Let MouseOverColor(ByVal New_FillColor As OLE_COLOR)
    m_MouseOverColor = New_FillColor
    PropertyChanged "FillColor"
End Property

